/*
*****************************************************************************************************************************************************
Projet Centrale domotique DomoMaison 2017 pour carte Arduino Mega 2560 et carte Ethernet (W5100)
Version 1.70 du 06/09/2017
Copyright 2017 PRIN Jean-Luc
Ce programme fonctionne avec le protocole Websockets (HTML5).
*****************************************************************************************************************************************************
*/
/*
*****************************************************************************************************************************************************
Modules contenant les fonctions nécessaires à la gestion d'envoi d'email
*****************************************************************************************************************************************************
*/

#ifdef MAILCONF
// -------------------------------- Début de la fonction envoi_email (envoi d'email) ----------------------------------------------------------------
void verifie_envoi_email()
{
    byte i;
        if (((Seq_Envoi_Mail == 1) && (Ksmtp == 0)) || ((Seq_Envoi_Mail == 1) && (Ksmtp != 0) && (Tempo_Mail_Interval >= ATTENTE_SERVEUR_SMTP))){
            // Definition de la date du mail
            switch (weekday(Epoch_Local)) {
                case 1:
                    strncpy(&Date_Mail_Smtp[0], "Dim", 3);
                    break;
                case 2:
                    strncpy(&Date_Mail_Smtp[0], "Lun", 3);
                    break;
                case 3:
                    strncpy(&Date_Mail_Smtp[0], "Mar", 3);
                    break;
                case 4:
                    strncpy(&Date_Mail_Smtp[0], "Mer", 3);
                    break;
                case 5:
                    strncpy(&Date_Mail_Smtp[0], "Jeu", 3);
                    break;
                case 6:
                    strncpy(&Date_Mail_Smtp[0], "Ven", 3);
                    break;
                case 7:
                    strncpy(&Date_Mail_Smtp[0], "Sam", 3);
                    break;
                default:
                    break;
            }
            sprintf(Texte_Prov_Mail, "%d", day(Epoch_Local));
                if (day(Epoch_Local) < 10){
                    Date_Mail_Smtp[5] = '0';
                    strncpy(&Date_Mail_Smtp[6], Texte_Prov_Mail, 1);
                }
                else {
                    strncpy(&Date_Mail_Smtp[5], Texte_Prov_Mail, 2);
                }
            //élaboration du mois.
            switch (month(Epoch_Local)) {
                case 1:
                    strncpy(&Date_Mail_Smtp[8], "Jan", 3);
                    break;
                case 2:
                    strncpy(&Date_Mail_Smtp[8], "Fev", 3);
                    break;
                case 3:
                    strncpy(&Date_Mail_Smtp[8], "Mar", 3);
                    break;
                case 4:
                    strncpy(&Date_Mail_Smtp[8], "Avr", 3);
                    break;
                case 5:
                    strncpy(&Date_Mail_Smtp[8], "Mai", 3);
                    break;
                case 6:
                    strncpy(&Date_Mail_Smtp[8], "Jun", 3);
                    break;
                case 7:
                    strncpy(&Date_Mail_Smtp[8], "Jul", 3);
                    break;
                case 8:
                    strncpy(&Date_Mail_Smtp[8], "Aou", 3);
                    break;
                case 9:
                    strncpy(&Date_Mail_Smtp[8], "Sep", 3);
                    break;
                case 10:
                    strncpy(&Date_Mail_Smtp[8], "Oct", 3);
                    break;
                case 11:
                    strncpy(&Date_Mail_Smtp[8], "Nov", 3);
                    break;
                case 12:
                    strncpy(&Date_Mail_Smtp[8], "Dec", 3);
                    break;
                default:
                    break;
            }
            //élaboration année.
            sprintf(Texte_Prov_Mail, "%d", year(Epoch_Local));
            strncpy(&Date_Mail_Smtp[12], &Texte_Prov_Mail[2], 2);
            //élaboration heure.
            sprintf(Texte_Prov_Mail, "%d", hour(Epoch_Local));
                if (hour(Epoch_Local) < 10){
                    Date_Mail_Smtp[15] = '0';
                    strncpy(&Date_Mail_Smtp[16], Texte_Prov_Mail, 1);
                }
                else {
                    strncpy(&Date_Mail_Smtp[15], Texte_Prov_Mail, 2);
                }
            //élaboration minute.
            sprintf(Texte_Prov_Mail, "%d", minute(Epoch_Local));
                if (minute(Epoch_Local) < 10){
                    Date_Mail_Smtp[18] = '0';
                    strncpy(&Date_Mail_Smtp[19], Texte_Prov_Mail, 1);
                }
                else {
                    strncpy(&Date_Mail_Smtp[18], Texte_Prov_Mail, 2);
                }
            //élaboration seconde.
            sprintf(Texte_Prov_Mail, "%d", second(Epoch_Local));
                if (second(Epoch_Local) < 10){
                    Date_Mail_Smtp[21] = '0';
                    strncpy(&Date_Mail_Smtp[22], Texte_Prov_Mail, 1);
                }
                else {
                    strncpy(&Date_Mail_Smtp[21], Texte_Prov_Mail, 2);
                }
            //Elaboration du message suivant le code.
                for (i=0; i< sizeof(Message_Mail_Smtp) - 1; i++){
                    Message_Mail_Smtp[i] = ' ';
                }
            switch (Num_Message_Mail) {
                case 0:
                    strncpy(&Message_Mail_Smtp[0], TEXTE_MAIL_00,30);
                    break;
                case 1:
                    strncpy(&Message_Mail_Smtp[0], TEXTE_MAIL_01,30);
                    break;
                case 2:
                    strncpy(&Message_Mail_Smtp[0], TEXTE_MAIL_02,30);
                    //strcpy(&Message_Mail_Smtp[0], "HCHC=");
                    //sprintf(Texte_Prov_Mail, "%9.9ld", Hchc1);
                    //strcat(&Message_Mail_Smtp[0], Texte_Prov_Mail);
                    //strcat(&Message_Mail_Smtp[0], " HCHP=");
                    //sprintf(Texte_Prov_Mail, "%9.9ld", Hchp1);
                    //strcat(&Message_Mail_Smtp[0], Texte_Prov_Mail);
                    break;
                case 3:
                    strncpy(&Message_Mail_Smtp[0], TEXTE_MAIL_03,30);
                    break;
                case 4:
                    strncpy(&Message_Mail_Smtp[0], TEXTE_MAIL_04,30);
                    break;
                case 5:
                    strncpy(&Message_Mail_Smtp[0], TEXTE_MAIL_05,30);
                    break;
                default:
                    break;
            }
            #ifdef DEBUG_MAIL
                Serial.print(F("date mail : "));
                Serial.println(Date_Mail_Smtp);
                Serial.print(F("message mail : "));
                Serial.println(Message_Mail_Smtp);
            #endif

            //Sélection du serveur smtp.
            switch (Ksmtp) {
                case 0:
                    for (i=0; i< 4; i++){
                        Server_Mail[i] = SERVER_MAIL_00[i];
                    }
                    break;
                case 1:
                    for (i=0; i< 4; i++){
                        Server_Mail[i] = SERVER_MAIL_01[i];
                    }
                    break;
                case 2:
                    for (i=0; i< 4; i++){
                        Server_Mail[i] = SERVER_MAIL_02[i];
                    }
                    break;
                case 3:
                    for (i=0; i< 4; i++){
                        Server_Mail[i] = SERVER_MAIL_03[i];
                    }
                    break;
                case 4:
                    for (i=0; i< 4; i++){
                        Server_Mail[i] = SERVER_MAIL_04[i];
                    }
                    break;
                case 5:
                    for (i=0; i< 4; i++){
                        Server_Mail[i] = SERVER_MAIL_05[i];
                    }
                    break;
                default:
                    for (i=0; i< 4; i++){
                        Server_Mail[i] = 0;
                    }
                    break;
            }

                if (client_mail.connect(Server_Mail,PORT_COMPUTER_MAIL)) {
                    #ifdef DEBUG_MAIL
                        Serial.println(F("connexion au serveur smtp OK"));
                    #endif
                    Seq_Envoi_Mail = 101;
                    Tempo_Mail_Interval = 0;
                    Ksmtp = 0;
                }
                else {
                    client_mail.stop();
                    #ifdef DEBUG_MAIL
                        Serial.println(F("Echec connexion au serveur smtp"));
                    #endif
                        if (Ksmtp >= 5){
                            Seq_Envoi_Mail = 0;
                            Tempo_Mail_Interval = 0;
                            Ksmtp = 0;
                        }
                        else {
                            Tempo_Mail_Interval = 0;
                            Ksmtp++;
                        }
                }
        }

		if ((Seq_Envoi_Mail == 101)&& (Tempo_Mail_Interval >= ATTENTE_MAIL)){
			checkEmail();
            #ifdef DEBUG_MAIL
                Serial.println(F("Fin Procedure de connexion et suite"));
            #endif
			if((strstr(SerInStringSmtp,"220") != NULL) && (Seq_Envoi_Mail == 101)) {
				//passer à la séquence suivante .
				Seq_Envoi_Mail = 2;
                #ifdef DEBUG_MAIL
                    Serial.println(F("comparaison 220 OK"));
                #endif
			}
			else{
				client_mail.println(F("QUIT"));                                 //envoi du quit car un appel a été effectué.
				Seq_Envoi_Mail = 0;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("echec comparaison  CR 220 : abandon"));
                #endif
			}
		}
		if ((Seq_Envoi_Mail == 2) && (Tempo_Mail_Interval >= 10)){
            #ifdef DEBUG_MAIL
                Serial.println(F("Sequence HELO..."));
            #endif
			client_mail.println(F("EHLO PRINUS"));                              //envoi du HELO ou EHLO.
			Seq_Envoi_Mail = 3;
			Tempo_Mail_Interval = 0;
		}
		if ((Seq_Envoi_Mail == 3) && (Tempo_Mail_Interval >= ATTENTE_MAIL)) {
            #ifdef DEBUG_MAIL
                Serial.println(F("Decodage du CR HELO..."));
            #endif
			checkEmail();
			//Détection chaine de compte-rendu du HELO
            #ifdef DEBUG_MAIL
                Serial.println(F("comparaison 250 du EHLO"));
            #endif
			if((strstr(SerInStringSmtp,"250") != NULL) && (Seq_Envoi_Mail == 3)) {
				//passer à la séquence suivante .
				Seq_Envoi_Mail = 4;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("comparaison 250 OK"));
                #endif
			}
			else{
				client_mail.println(F("QUIT"));                                     //envoi du quit car un appel a été effectué.
				Seq_Envoi_Mail = 0;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("CR du HELO inconnu"));
                #endif
			}
		}
		if ((Seq_Envoi_Mail == 4) && (Tempo_Mail_Interval >= 10)) {
            #ifdef DEBUG_MAIL
                Serial.println(F("Envoi ordre Auth Plain ou login."));
            #endif
			client_mail.println(F("AUTH PLAIN"));                                   //Envoi du type d'authentification.
			Seq_Envoi_Mail = 5;
			Tempo_Mail_Interval = 0;
		}
		if ((Seq_Envoi_Mail == 5) && (Tempo_Mail_Interval >= ATTENTE_MAIL)) {
            #ifdef DEBUG_MAIL
                Serial.println(F("Decodage du CR AUTH..."));
            #endif
			checkEmail();
			//Détection chaine de compte-rendu .
            #ifdef DEBUG_MAIL
                Serial.println(F("comparaison 334 du AUTH"));
            #endif
			if((strstr(SerInStringSmtp,"334") != NULL) && (Seq_Envoi_Mail == 5)) {
				//passer à la séquence suivante .
				Seq_Envoi_Mail = 6;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("comparaison 334 OK"));
                #endif
			}
			else{
				client_mail.println(F("QUIT"));                                     //envoi du quit car un appel a été effectué.
				Seq_Envoi_Mail = 0;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("CR du AUTH inconnu"));
                #endif
			}
		}
		if ((Seq_Envoi_Mail == 6) && (Tempo_Mail_Interval >= 10)) {
            #ifdef DEBUG_MAIL
                Serial.println(F("Envoi du code authentifiant."));
            #endif
			client_mail.println(Code_Auth_Plain);                                   //Envoi du type d'authentification.
			Seq_Envoi_Mail = 7;
			Tempo_Mail_Interval = 0;
		}
		if ((Seq_Envoi_Mail == 7) && (Tempo_Mail_Interval >= ATTENTE_MAIL)) {
            #ifdef DEBUG_MAIL
                Serial.println(F("Decodage du CR de l'envoi du code PLAIN..."));
            #endif
			checkEmail();
			//Détection chaine de compte-rendu .
            #ifdef DEBUG_MAIL
                Serial.println(F("comparaison 235 du code"));
            #endif
			if((strstr(SerInStringSmtp,"235") != NULL) && (Seq_Envoi_Mail == 7)) {
				//passer à la séquence suivante .
				Seq_Envoi_Mail = 8;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("comparaison 235 OK"));
                #endif
			}
			else{
				client_mail.println(F("QUIT"));//envoi du quit car un appel a été effectué.
				Seq_Envoi_Mail = 0;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("CR du code PLAIN incorrect"));
                #endif
			}
		}
		if ((Seq_Envoi_Mail == 8) && (Tempo_Mail_Interval >= 10)) {
            #ifdef DEBUG_MAIL
                Serial.println(F("Envoi de expediteur"));
            #endif
			client_mail.print(F("MAIL FROM:"));
			client_mail.println(Expediteur_Smtp);
			Seq_Envoi_Mail = 9;
			Tempo_Mail_Interval = 0;
		}
		if ((Seq_Envoi_Mail == 9) && (Tempo_Mail_Interval >= ATTENTE_MAIL)) {
            #ifdef DEBUG_MAIL
                Serial.println(F("Decodage du CR de l'envoi de l'expediteur..."));
            #endif
			checkEmail();
			//Détection chaine de compte-rendu .
            #ifdef DEBUG_MAIL
                Serial.println(F("comparaison 250 du code"));
            #endif
			if((strstr(SerInStringSmtp,"250") != NULL) && (Seq_Envoi_Mail == 9)) {
				//passer à la séquence suivante .
				Seq_Envoi_Mail = 10;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("comparaison expediteur 250 OK"));
                #endif
			}
			else{
				client_mail.println(F("QUIT"));                             //envoi du quit car un appel a été effectué.
				Seq_Envoi_Mail = 0;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("CR du code expediteur incorrect"));
                #endif
			}
		}
		if ((Seq_Envoi_Mail == 10) && (Tempo_Mail_Interval >= 10)) {
            #ifdef DEBUG_MAIL
                Serial.println(F("Envoi du destinataire"));
            #endif
			client_mail.print(F("RCPT TO:"));//
			client_mail.println(Destinataire_Smtp);//
			Seq_Envoi_Mail = 11;
			Tempo_Mail_Interval = 0;
		}
		if ((Seq_Envoi_Mail == 11) && (Tempo_Mail_Interval >= ATTENTE_MAIL)) {
            #ifdef DEBUG_MAIL
                Serial.println(F("Decodage du CR de l'envoi du destinataire..."));
            #endif
			checkEmail();
			//Détection chaine de compte-rendu .
            #ifdef DEBUG_MAIL
                Serial.println(F("comparaison 250 du code"));
            #endif
			if((strstr(SerInStringSmtp,"250") != NULL) && (Seq_Envoi_Mail == 11)) {
				//passer à la séquence suivante .
				if (sizeof(Copie_Smtp) < 2) Seq_Envoi_Mail = 12;
				else Seq_Envoi_Mail = 110;                                              //passer à la séquence avec destinataire en copie.
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("comparaison destinataire 250 OK"));
                #endif
			}
			else{
				client_mail.println(F("QUIT"));                                         //envoi du quit car un appel a été effectué.
				Seq_Envoi_Mail = 0;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("CR du code destinataire incorrect"));
                #endif
			}
		}
		if ((Seq_Envoi_Mail == 110) && (Tempo_Mail_Interval >= 10)) {
            #ifdef DEBUG_MAIL
                Serial.println(F("Envoi du destinataire en copie"));
            #endif
			client_mail.print(F("RCPT TO:"));//
			client_mail.println(Copie_Smtp);//
			Seq_Envoi_Mail = 111;
			Tempo_Mail_Interval = 0;
		}
		if ((Seq_Envoi_Mail == 111) && (Tempo_Mail_Interval >= ATTENTE_MAIL)) {
            #ifdef DEBUG_MAIL
                Serial.println(F("Decodage du CR de l'envoi du destinataire en copie..."));
            #endif
			checkEmail();
			//Détection chaine de compte-rendu .
            #ifdef DEBUG_MAIL
                Serial.println(F("comparaison 250 du code"));
            #endif
			if((strstr(SerInStringSmtp,"250") != NULL) && (Seq_Envoi_Mail == 111)) {
				//passer à la séquence suivante .
				Seq_Envoi_Mail = 12;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("comparaison destinataire en copie 250 OK"));
                #endif
			}
			else{
				client_mail.println(F("QUIT"));                                             //envoi du quit car un appel a été effectué.
				Seq_Envoi_Mail = 0;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("CR du code destinataire en copie incorrect"));
                #endif
			}
		}
		//Envoi de DATA.
		if ((Seq_Envoi_Mail == 12) && (Tempo_Mail_Interval >= 10)) {
            #ifdef DEBUG_MAIL
                Serial.println(F("Envoi de DATA"));
            #endif
			client_mail.println(F("DATA"));//
			Seq_Envoi_Mail = 13;
			Tempo_Mail_Interval = 0;
		}
		if ((Seq_Envoi_Mail == 13) && (Tempo_Mail_Interval >= ATTENTE_MAIL)) {
            #ifdef DEBUG_MAIL
                Serial.println(F("Decodage du CR de l'envoi de DATA..."));
            #endif
			checkEmail();
			//Détection chaine de compte-rendu .
            #ifdef DEBUG_MAIL
                Serial.println(F("comparaison 354 du code"));
            #endif
			if((strstr(SerInStringSmtp,"354") != NULL) && (Seq_Envoi_Mail == 13)) {
				//passer à la séquence suivante .
				Seq_Envoi_Mail = 14;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("comparaison DATA 354 OK"));
                #endif
			}
			else{
				client_mail.println(F("QUIT"));                                         //envoi du quit car un appel a été effectué.
				Seq_Envoi_Mail = 0;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("CR du code DATA incorrect"));
                #endif
			}
		}
		if ((Seq_Envoi_Mail == 14) && (Tempo_Mail_Interval >= 10)) {
            #ifdef DEBUG_MAIL
                Serial.println(F("Envoi de l'entete et des donnees du mail"));
            #endif
			client_mail.print(F("Date: "));
			client_mail.println(Date_Mail_Smtp);
			client_mail.print(F("From: "));
			client_mail.println(Expediteur_Smtp);                               //expéditeur.
			client_mail.print(F("To: "));
			client_mail.println(Destinataire_Smtp);                             //destinataire.
			if (sizeof(Copie_Smtp) > 1){
				client_mail.print(F("CC: "));
				client_mail.println(Copie_Smtp);                                //destinataire en copie.
			}
			client_mail.print(F("SUBJECT: "));
			client_mail.print(Subject_Mail_Smtp);
			client_mail.print(F("\r\n\r\n"));
			client_mail.print(Message_Mail_Smtp);
			client_mail.print(F("\r\n.\r\n"));
			Seq_Envoi_Mail = 15;
			Tempo_Mail_Interval = 0;
		}
		if ((Seq_Envoi_Mail == 15) && (Tempo_Mail_Interval >= ATTENTE_MAIL)) {
            #ifdef DEBUG_MAIL
                Serial.println(F("Decodage du CR de l'envoi des donnees du mail..."));
            #endif
			checkEmail();
			//Détection chaine de compte-rendu .
            #ifdef DEBUG_MAIL
                Serial.println(F("comparaison 250 du code"));
            #endif
			if((strstr(SerInStringSmtp,"250") != NULL) && (Seq_Envoi_Mail == 15)) {
				//passer à la séquence suivante .
				Seq_Envoi_Mail = 16;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("comparaison donnees 250 OK"));
                #endif
			}
			else{
				client_mail.println(F("QUIT"));                                     //envoi du quit car un appel a été effectué.
				Seq_Envoi_Mail = 0;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("CR du code donnees incorrect"));
                #endif
			}
		}
		if ((Seq_Envoi_Mail == 16) && (Tempo_Mail_Interval >= 10)) {
            #ifdef DEBUG_MAIL
                Serial.println(F("Envoi de QUIT"));
            #endif
			client_mail.println(F("QUIT"));
			Seq_Envoi_Mail = 17;
			Tempo_Mail_Interval = 0;
		}
		if ((Seq_Envoi_Mail == 17) && (Tempo_Mail_Interval >= ATTENTE_MAIL)) {
            #ifdef DEBUG_MAIL
                Serial.println(F("Decodage du CR de l'envoi de QUIT..."));
            #endif
			checkEmail();
			//Détection chaine de compte-rendu .
            #ifdef DEBUG_MAIL
                Serial.println(F("comparaison 221 du code"));
            #endif
			if((strstr(SerInStringSmtp,"221") != NULL) && (Seq_Envoi_Mail == 17)) {
				//passer à la séquence suivante .
				Seq_Envoi_Mail = 100;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("comparaison donnees 221 OK"));
                #endif
 			}
			else{
				client_mail.println(F("QUIT"));                                     //envoi du quit car un appel a été effectué.
				Seq_Envoi_Mail = 0;
				Tempo_Mail_Interval = 0;
                #ifdef DEBUG_MAIL
                    Serial.println(F("CR du code quit incorrect"));
                #endif
			}
		}
		// Re-init de la periode de la boucle de base.
		Tempo_Mail_Interval = Tempo_Mail_Interval + 1;
		if (Tempo_Mail_Interval >= 20000) Tempo_Mail_Interval = 0;                  //Reset temporisation de l'automate d'envoi de email.
		//----------------fin du traitement de l'automate d'envoi d'e-mail-----------------------------------------
		//
		//----------------Mécanisme d'envoi de mail lors du Reset de la carte Arduino--------------------------
		if ((Indic_Start_Mail == 0) && (year(Epoch_Local) != 1970)){                //attente de date correcte avant d'envoyer le message mail de démarrage de la carte (stabilisation).
			Indic_Start_Mail = 1;                                                   //spécifie que d'autres e-mail peuvent ête envoyés.
			if ((Seq_Envoi_Mail == 0)|| (Seq_Envoi_Mail == 100)){
				Seq_Envoi_Mail = 1;                                                 //demande d'envoi de mail.
				Num_Message_Mail = 0;                                               //numéro du message de connexion à transmettre par mail.
			}
		}
		//-----------------------------------------------------------------------------------------------------------------------
		//
		//----------------Mécanisme d'envoi de l'e-mail de controle journalier--------------------------
		if ((hour(Epoch_Local) == HEURE_MAIL) && (minute(Epoch_Local) == MINUTE_MAIL) && (Indic_Mail_Controle_Journalier == 0)){
			Indic_Mail_Controle_Journalier = 1;
			if ((Seq_Envoi_Mail == 0)|| (Seq_Envoi_Mail == 100)){
				Seq_Envoi_Mail = 1;                                     //demande d'envoi de mail.
				Num_Message_Mail = 2;                                   //numéro du message de connexion à transmettre par mail.
			}
		}
		if (minute(Epoch_Local)!= MINUTE_MAIL){
			Indic_Mail_Controle_Journalier = 0;
		}
		//-----------------------------------------------------------------------------------------------------------------------
		//
		//----------------Mécanisme d'envoi de mail en cas de détection de présence par les contacteurs d'ouverture-----------
		//test si le commutateur présence/absence est sur absent.
		if (Indic_Present_Absent == 0){
			// Envoi mail sur effraction sur contacteurs d'ouverture.
            if (Indic_Alarme_Ouvert == 1) {
				//contrôle du filtre sur la date du précédent événement pour éviter l'avalanche de mail.
                if ((Epoch_Local - Evenement_Con) >= DUREE_FILTRE_EVENEMENT) {
					//séquence d'envoi d'e-mail.
                    if ((Seq_Envoi_Mail == 0)|| (Seq_Envoi_Mail == 100)){
						Seq_Envoi_Mail = 1;                                 //demande d'envoi de mail.
						Num_Message_Mail = 3;                               //numéro du message d'événement à transmettre par mail.
                        Indic_Alarme_Ouvert = 0;                            // remise à zéro de l'indicateur d'effraction
                        Num_Indic_Con = 0;                                  // remise à zéro du numéro du contacteur ouverture déclenché en dernier
                    }
				}
				Evenement_Con = Epoch_Local;                                      //mise à jour du dernier événement de détection PIR.
			}
		}
		//-----------------------------------------------------------------------------------------------------------------------
		//
		//----------------Mécanisme d'envoi de mail en cas de détection de présence par le capteur PIR-----------
		//test si le commutateur présence/absence est sur absent.
		if (Indic_Present_Absent == 0){
			// Envoi mail sur effraction sur capteur PIR.
            if (Indic_Alarme_PIR == 1) {
				//contrôle du filtre sur la date du précédent événement pour éviter l'avalanche de mail.
                if ((Epoch_Local - Evenement_Pir) >= DUREE_FILTRE_EVENEMENT) {
					//séquence d'envoi d'e-mail.
                    if ((Seq_Envoi_Mail == 0)|| (Seq_Envoi_Mail == 100)){
						Seq_Envoi_Mail = 1;                                 //demande d'envoi de mail.
						Num_Message_Mail = 4;                               //numéro du message d'événement à transmettre par mail.
                        Indic_Alarme_PIR = 0;                               // remise à zéro de l'indicateur d'effraction
                        Num_Indic_Pir = 0;                                  // remise à zéro du numéro du contacteur ouverture déclenché en dernier
                    }
				}
				Evenement_Pir = Epoch_Local;                                //mise à jour du dernier événement de détection PIR.
			}
		}
		//-----------------------------------------------------------------------------------------------------------------------
        //
		//----------------Mécanisme d'envoi de mail en cas de dépassement du seuil d'intensité électrique IINST-----------
		//test si le commutateur présence/absence est sur absent.
		if (Indic_Present_Absent == 0){
			//Test détection d'événement de dépassement de seuil avec téléinfo en service.
			if ((Iinst1 >= SEUIL_MAIL_PUISSANCE_ABSCENT) && (Indic_Teleinfo1 == 1)){
				//contrôle du filtre sur la date du précédent événement pour éviter l'avalanche de mail.
				if ((Epoch_Local - Evenement_Papp) >= DUREE_FILTRE_EVENEMENT) {
					//séquence d'envoi d'e-mail.
					if ((Seq_Envoi_Mail == 0)|| (Seq_Envoi_Mail == 100)){
						Seq_Envoi_Mail = 1;                                 //demande d'envoi de mail.
						Num_Message_Mail = 5;                               //numéro du message d'événement à transmettre par mail.
					}
				}
				Evenement_Papp = Epoch_Local;                               //mise à jour du dernier événement de dépassement de seuil.
			}
		}
}
// -------------------------------- Fin de la fonction envoi_email (envoi d'email) ------------------------------------------------------------------

// -------------------- Début de la fonction checkEmail (réception des caractères émis par un serveur SMTP) -----------------------------------------
void checkEmail()
{
    int i,j;
    i = 0;
		if (!client_mail.connected()) {
			#ifdef DEBUG_MAIL
				Serial.println(F("Deconnexion du serveur et Fin procedure."));
			#endif
			client_mail.stop();
			Seq_Envoi_Mail = 0;
		}
		else{
			cleanup_smtp(SerInStringSmtp);
			while (client_mail.available()) {
				//stockage de la chaine de caractère reçue du serveur SMTP.
				SerInStringSmtp[i] = client_mail.read();
				#ifdef DEBUG_MAIL
					Serial.print(SerInStringSmtp[(i)]);
				#endif
				i++;
				// Traitement débordement du nombre de caractères lus sur la liaison ethernet.
				if (i >= Nbcarlu_Smtp){
					i--;
				}
			}
		}
	}
// -------------------- Fin de la fonction checkEmail (réception des caractères émis par un serveur SMTP) -------------------------------------------

// ------------------- Début de la fonction cleanup_smtp (RAZ de la zone de caractère de la liaison Mail en lecture) --------------------------------
	void cleanup_smtp(char *StrArray){
		for (int i=0; i< Nbcarlu_Smtp; i++){
			StrArray[i] = 0;
		}
	}
// ------------------- Fin de la fonction cleanup_smtp (RAZ de la zone de caractère de la liaison Mail en lecture) ----------------------------------
#endif
